From 493d7b6cf8b8cec672186bbd6ae2717ff421e531 Mon Sep 17 00:00:00 2001
From: Khanna <Shubham.Khanna@fujitsu.com>
Date: Mon, 2 Dec 2024 14:21:16 +0530
Subject: [PATCH v2] DOCS-Fix

There is a discrepancy in the pg_createsubscriber documentation on the
PostgreSQLwebsite:
https://www.postgresql.org/docs/17/app-pgcreatesubscriber.html

The options mentioned in the documentation:- 'publication-name' and
'subscription-name' do not align with the actual options provided by the tool:-
'--publication' and '--subscription'.

The changes in the Patch ensure the documentation accurately reflects the
tool's behavior and includes proper option names for clarity.
---
 doc/src/sgml/ref/pg_createsubscriber.sgml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/doc/src/sgml/ref/pg_createsubscriber.sgml b/doc/src/sgml/ref/pg_createsubscriber.sgml
index 04af154c4b..daeb9f6e96 100644
--- a/doc/src/sgml/ref/pg_createsubscriber.sgml
+++ b/doc/src/sgml/ref/pg_createsubscriber.sgml
@@ -407,7 +407,7 @@ PostgreSQL documentation
       Create a publication and replication slot for each specified database on
       the source server.  Each publication is created using <link
       linkend="sql-createpublication-params-for-all-tables"><literal>FOR ALL
-      TABLES</literal></link>.  If <option>publication-name</option> option is
+      TABLES</literal></link>.  If <option>--publication</option> option is
       not specified, it has the following name pattern:
       <quote><literal>pg_createsubscriber_%u_%x</literal></quote> (parameter:
       database <parameter>oid</parameter>, random <parameter>int</parameter>).
@@ -446,7 +446,7 @@ PostgreSQL documentation
     <step>
      <para>
       Create a subscription for each specified database on the target server.
-      If <option>subscription-name</option> is not specified, the subscription
+      If <option>--subscription</option> option is not specified, the subscription
       has the following name pattern:
       <quote><literal>pg_createsubscriber_%u_%x</literal></quote> (parameters:
       database <parameter>oid</parameter>, random <parameter>int</parameter>).
-- 
2.41.0.windows.3